## freecell-solver 2.20.0

=== CMakeLists.txt ===
INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/Common.cmake" )

# This is the equivalent to perform a "make dist"/"make distdir" etc.
SET(CPACK_PACKAGE_NAME "freecell-solver")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Freecell Solver")
SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")

# Process and extract the version number.
FILE( READ "ver.txt" VERSION)

CHOMP (VERSION)

STRING (REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")

LIST(GET VERSION_DIGITS 0 CPACK_PACKAGE_VERSION_MAJOR)
LIST(GET VERSION_DIGITS 1 CPACK_PACKAGE_VERSION_MINOR)
LIST(GET VERSION_DIGITS 2 CPACK_PACKAGE_VERSION_PATCH)

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET(CPACK_SOURCE_IGNORE_FILES
    "/_CPack_Packages/"
    "/CMakeFiles/"
    "/.deps/"
    "freecell-solver-[0-9]+\\\\.[0-9]+\\\\.[0-9]+(-Source|-Linux|)(/|\\\\.(sh|tar\\\\.(gz|bz2|Z|lzma|xz))$)"
    "\\\\.o$"
    "~$"
    "/board_gen/(pi-make-microsoft-freecell-board|make-microsoft-freecell-board|make-gnome-freecell-board|make-aisleriot-freecell-board)$"
    "/fc-solve$"
    "/libfcs\\\\.a$"
    "\\\\.so(\\\\.[0-9]+)*$"
    "/.svn/"
    "/t/t/.*\\\\.exe$"
    "/t/Presets"
    "/CMakeCache.txt$"
    "/Makefile$"
    "/CTestTestfile.cmake$"
    "/CPackConfig.cmake$"
    "/tags$"
    "/([0-9]+)\\\\.board$"
)

IF(WIN32 AND NOT UNIX)
    # There is a bug in NSI that does not handle full unix paths properly. Make
    # sure there is at least one set of four (4) backlasshes.
    SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}\\\\dondorf-king.bmp")
    SET(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\fc-solve.exe")
    SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\fc-solve.berlios.de")
    SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\fc-solve.berlios.de")
    SET(CPACK_NSIS_DISPLAY_NAME "Freecell Solver")
    SET(CPACK_NSIS_CONTACT "shlomif@iglu.org.il")
    SET(CPACK_NSIS_MODIFY_PATH ON)
    # Setting for NSIS :
    SET(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\fc-solve.ico")
    SET(CPACK_NSIS_MUI_UNIICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_PACKAGE_ICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_NSIS_MODIFY_PATH "ON")
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_STRIP_FILES "fc-solve")
  SET(CPACK_SOURCE_STRIP_FILES "")
ENDIF(WIN32 AND NOT UNIX)

SET(CPACK_PACKAGE_EXECUTABLES
    "fc-solve" "Single-Game Solver"
)

### This is to set the RPATH correctly, so when installed under a prefix
### the executables will find the libraries.
### 
### See:
###
### http://www.cmake.org/Wiki/CMake_RPATH_handling
###
### (Taken from that wiki page)

# use, i.e. don't skip the full RPATH for the build tree
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)


SET (INDIRECT_STACK_STATES 1)
SET (IA_STATE_PACKS_GROW_BY 32 CACHE STRING "Amount to Grow State Packs By")
SET (MAX_NUM_FREECELLS 8 CACHE STRING "Maximal Number of Freecells")
SET (MAX_NUM_STACKS 10 CACHE STRING "Maximal Number of Stacks")
SET (MAX_NUM_INITIAL_CARDS_IN_A_STACK 8 CACHE STRING
    "Maximal Number of Initial Cards in a Stack")
SET (MAX_NUM_DECKS 2 CACHE STRING "Maximal Number of Decks (1 or 2)")

SET (FCS_STATE_STORAGE "FCS_STATE_STORAGE_INTERNAL_HASH" CACHE STRING "The State Storage Type")
SET (FCS_STACK_STORAGE "FCS_STACK_STORAGE_INTERNAL_HASH" CACHE STRING "The Stack Storage Type")

SET (FCS_FRECELL_ONLY "" CACHE BOOL "Configure Freecell Solver to only be able to solve Freecell")

# Search for libredblack if appropriate.
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBREDBLACK_TREE") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBREDBLACK_TREE"))

    FIND_LIBRARY(LIBREDBLACK_LIB redblack)

ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBREDBLACK_TREE") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBREDBLACK_TREE"))

# Search for Judy ( http://judy.sourceforge.net/ ) if appropriate.
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY"))

    FIND_LIBRARY(LIBJUDY_LIB Judy)

ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
       (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY"))

INCLUDE(CPack)

include(CheckFunctionExists)
INCLUDE(CheckCCompilerFlag)

ADD_SUBDIRECTORY ("board_gen")
ADD_SUBDIRECTORY ("man")
ADD_SUBDIRECTORY ("Presets")

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

SET (CFLAG_TO_CHECK "-Wall")
CHECK_C_COMPILER_FLAG(${CFLAG_TO_CHECK} CFLAG_GCC_ALL_WARNS)
IF (${CFLAG_GCC_ALL_WARNS})
    ADD_DEFINITIONS(${CFLAG_TO_CHECK})
ENDIF (${CFLAG_GCC_ALL_WARNS})

ADD_LIBRARY (freecell-solver
    SHARED
    alloc.c app_str.c caas.c card.c cl_chop.c cmd_line.c fcs_dm.c fcs_hash.c fcs_isa.c freecell.c intrface.c lib.c lookup2.c move.c pqueue.c preset.c rand.c scans.c simpsim.c state.c
    )

SET_TARGET_PROPERTIES(freecell-solver
    PROPERTIES VERSION 0.5.0 SOVERSION 0
    )

TARGET_LINK_LIBRARIES (freecell-solver m ${LIBREDBLACK_LIB} ${LIBJUDY_LIB})

ADD_EXECUTABLE (fc-solve
    main.c
)

ADD_EXECUTABLE (freecell-solver-range-parallel-solve
    test_multi_parallel.c
)

CHECK_FUNCTION_EXISTS(pow HAVE_POW)

TARGET_LINK_LIBRARIES (fc-solve freecell-solver)
TARGET_LINK_LIBRARIES (freecell-solver-range-parallel-solve freecell-solver)

CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h
    )

CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/prefix.h.in
    ${CMAKE_CURRENT_SOURCE_DIR}/prefix.h
    )

CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/${CPACK_PACKAGE_NAME}.spec.in
    ${CMAKE_CURRENT_SOURCE_DIR}/${CPACK_PACKAGE_NAME}.spec
    )

CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/${CPACK_PACKAGE_NAME}-config.in
    ${CMAKE_CURRENT_SOURCE_DIR}/${CPACK_PACKAGE_NAME}-config
    )

INSTALL(
    TARGETS "fc-solve" "freecell-solver-range-parallel-solve"
    DESTINATION "bin"
)

INSTALL(
    TARGETS "freecell-solver"
    DESTINATION "lib"
)

IF (WIN32 AND NOT UNIX)
    # This is so on Windows, the .dll's will be installed in the bin/ 
    # directory as well where the Freecell Solver command-line utilities
    # will be able to find them.

    INSTALL(
        TARGETS "freecell-solver"
        DESTINATION "bin"
    )
ENDIF (WIN32 AND NOT UNIX)

INSTALL(
    FILES "freecell-solver-config"
    DESTINATION "bin"
)

RUN_POD2MAN(
    "fc-solve.pod"
    "fc-solve.6"
    "6"
    "Freecell Solver"
    "Freecell Solver ${VERSION}"
)

INSTALL_MAN ("fc-solve.6" 6)

INSTALL(
    FILES
        "AUTHORS"
        "INSTALL"
        "README"
        "README.win32.txt"
        "TODO"
        "USAGE"
    DESTINATION
        "share/doc/freecell-solver/"
)

INSTALL(
    FILES
        "fcs_cl.h"
        "fcs_enums.h"
        "fcs_move.h"
        "fcs_user.h"
    DESTINATION
        "include/freecell-solver"
)

# Rebuild config.h if ver.txt has changed.
ADD_CUSTOM_COMMAND(
    OUTPUT "config.h.in"
    DEPENDS "ver.txt"
    COMMAND "touch"
    ARGS "config.h.in"
)

SET (BOARDS "")

MACRO(GEN_BOARD idx)
    SET(board "${idx}.board")
    ADD_CUSTOM_COMMAND(
        OUTPUT ${board}
        COMMAND "python"
        ARGS "board_gen/make_pysol_freecell_board.py" ${idx} ">" ${board}
    )
    SET(BOARDS ${BOARDS} ${board})
ENDMACRO(GEN_BOARD idx)

FOREACH(idx 24 1941)
    GEN_BOARD(${idx})
ENDFOREACH(idx)

ADD_CUSTOM_TARGET(
    boards
    DEPENDS ${BOARDS}
)

ENABLE_TESTING()

ADD_TEST(
    tap-tests
    perl run-tests.pl
)

=== Presets/CMakeLists.txt ===
INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/../Common.cmake" )

SUBDIRS( presets )

CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/presetrc.proto.in
    ${CMAKE_CURRENT_SOURCE_DIR}/presetrc
)

INSTALL(
    FILES
        "presetrc"
    DESTINATION
        "${PKGDATADIR}"
)

=== board_gen/CMakeLists.txt ===
INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/../Common.cmake" )

ADD_EXECUTABLE (
    make-gnome-freecell-board
    make_gnome_freecell_board.c
)

ADD_EXECUTABLE(
    make-aisleriot-freecell-board
    make_aisleriot_freecell_board.c
)

ADD_EXECUTABLE(
    make-microsoft-freecell-board
    make_microsoft_freecell_board.c
)

ADD_EXECUTABLE(
    pi-make-microsoft-freecell-board
    pi_make_microsoft_freecell_board.c
)

RUN_POD2MAN(
    "fc-solve-board_gen.pod"
    "fc-solve-board_gen.6"
    "6"
    "board_gen"
    "board_gen ${VERSION}"
)

INSTALL_MAN("fc-solve-board_gen.6" 6)

# Install the nroff symbolic links.
INSTALL_MAN ("make-aisleriot-freecell-board.6" 6)
INSTALL_MAN ("make-gnome-freecell-board.6" 6)
INSTALL_MAN ("make_pysol_freecell_board.py.6" 6)
INSTALL_MAN ("pi-make-microsoft-freecell-board.6" 6)

INSTALL(
    TARGETS
        "make-gnome-freecell-board"
        "pi-make-microsoft-freecell-board"
        "make-aisleriot-freecell-board"
        "make-microsoft-freecell-board"
    DESTINATION
        "bin"
)

INSTALL(
    PROGRAMS
        "make_pysol_freecell_board.py"
    DESTINATION
        "bin"
)

=== man/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

SET(CMAKE_VERBOSE_MAKEFILE ON)

INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/../Common.cmake" )

RUN_POD2MAN(
    "freecell-solver-range-parallel-solve.pod"
    "freecell-solver-range-parallel-solve.6"
    "6"
    "Freecell Solver"
    "Freecell Solver ${VERSION}"
)

INSTALL_MAN ( "freecell-solver-range-parallel-solve.6" 6)

=== Presets/presets/CMakeLists.txt ===
INSTALL(
    FILES
        "abra-kadabra.sh"
        "cool-jives.sh"
        "crooked-nose.sh"
        "fools-gold.sh"
        "hello-world.sh"
        "john_galt_line-500.sh"
        "rin-tin-tin.sh"
        "yellow-brick-road.sh"
    DESTINATION
        "${PKGDATADIR}/presets"
)

## freecell-solver 2.8.6-1

=== debian/changelog ===
freecell-solver (2.8.6-1) unstable; urgency=low

  * New upstream release
    - added new config.guess, sub and friends (closes: #177573)

 -- RISKO Gergely <risko@debian.org>  Fri, 21 Mar 2003 08:00:52 +0100

freecell-solver (2.8.3-2) unstable; urgency=low

  * regenerated configure and friends with new libtool (closes: #177189)

 -- RISKO Gergely <risko@debian.org>  Sat, 18 Jan 2003 16:57:27 +0100

freecell-solver (2.8.3-1) unstable; urgency=low

  * New upstream release

 -- RISKO Gergely <risko@debian.org>  Fri, 17 Jan 2003 14:45:59 +0100

freecell-solver (2.8.2-1) unstable; urgency=low

  * New upstream version
  * now using more upstream man pages

 -- RISKO Gergely <risko@debian.org>  Sun, 10 Nov 2002 18:09:28 +0100

freecell-solver (2.8.0-1) unstable; urgency=low

  * New upstream release

 -- RISKO Gergely <risko@debian.org>  Wed,  2 Oct 2002 16:38:40 +0200

freecell-solver (2.6.3-1) unstable; urgency=low

  * new upstream release

 -- RISKO Gergely <risko@debian.org>  Thu, 29 Aug 2002 19:13:53 +0200

freecell-solver (2.6.2-1) unstable; urgency=low

  * new upstream release 

 -- RISKO Gergely <risko@debian.org>  Thu, 25 Jul 2002 17:12:37 +0200

freecell-solver (2.6.0-1) unstable; urgency=low

  * new upstream release
  * wow, it's not native now, I hope it won't be native again...

 -- RISKO Gergely <risko@debian.org>  Tue, 16 Jul 2002 17:37:29 +0200

freecell-solver (2.4.2.1) unstable; urgency=low

  * new upstream release
  * since now this is a native debian package

 -- RISKO Gergely <risko@debian.org>  Tue,  2 Jul 2002 14:33:01 +0200

freecell-solver (2.4.1-1) unstable; urgency=low

  * new upstream version.

 -- RISKO Gergely <risko@debian.org>  Sat,  6 Apr 2002 11:35:18 +0200

freecell-solver (2.2.2-1) unstable; urgency=low

  * New upstream version.

 -- RISKO Gergely <risko@debian.org>  Sat, 23 Feb 2002 19:26:54 +0100

freecell-solver (2.0.0-2) unstable; urgency=low

  * copyright file fix (closes: Bug#126593) 

 -- RISKO Gergely <risko@debian.org>  Thu, 27 Dec 2001 12:26:39 +0100

freecell-solver (2.0.0-1) unstable; urgency=low

  * The package is now lintian clean.
  * New upstream version.

 -- RISKO Gergely <risko@debian.org>  Mon, 24 Dec 2001 10:59:04 +0100

freecell-solver (1.10.1-1) unstable; urgency=low

  * New upstream release

 -- RISKO Gergely <risko@debian.org>  Wed, 21 Dec 2001 18:51:23 +0100

freecell-solver (1.8.2-1) unstable; urgency=low

  * New upstream release
  * Everything except freecell-solver-bin is lintian clean

 --  <yotam@makif.omer.k12.il>  Sat, 22 Sep 2001 16:56:40 +0300

freecell-solver (1.6.7-1) unstable; urgency=low

  * New upstream release

 -- Yotam Rubin <yotam@makif.omer.k12.il>  Mon, 11 Jun 2001 02:51:44 +0300

freecell-solver (1.6.6-1) unstable; urgency=low

  * New upstream release

 -- Yotam Rubin <yotam@makif.omer.k12.il>  Thu, 31 May 2001 23:27:56 +0300

freecell-solver (1.6.5-1) unstable; urgency=low

  * New upstream release

 -- Yotam Rubin <yotam@makif.omer.k12.il>  Sun, 27 May 2001 02:10:08 +0300

freecell-solver (1.6.4-1) unstable; urgency=low

  * First Debian release

 -- Yotam Rubin <yotam@makif.omer.k12.il>  Wed, 23 May 2001 22:53:00 +0300

 

=== debian/control ===
Source: freecell-solver
Section: devel
Priority: optional
Maintainer: RISKO Gergely <risko@debian.org>
Standards-Version: 3.5.6
Build-depends: automake, libtool

Package: libfreecell-solver0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}
Description: Library for solving Freecell games
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and 
 static libraries necessary for developing programs using Freecell Solver.

Package: libfreecell-solver-dev
Architecture: any
Depends: libfreecell-solver0 (>= 2.0.0)
Description: Library for solving Freecell games (Development files)
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and 
 static libraries necessary for developing programs using Freecell Solver.
 .
 This package contains the files necessary to produce binaries which are
 linked against libfreecell-solver.
 
Package: freecell-solver-bin
Architecture: any
Section: games
Depends: ${shlibs:Depends}, python | python-base
Description: Library for solving Freecell games
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and 
 static libraries necessary for developing programs using Freecell Solver.
 .
 This package contains the binaries included with freecell-solver

=== debian/rules ===
#!/usr/bin/make -f 

PACKAGEshd=libfreecell-solver0
PACKAGEdev=libfreecell-solver-dev
PACKAGEbin=freecell-solver-bin


arch	= $(shell dpkg --print-architecture)
tmp	= debian/tmp
tmp-dev = debian/tmp-dev
tmp-bin = debian/tmp-bin

docdir		= usr/share/doc
mandir		= usr/share/man
bindir 		= usr/bin

build: config.status
	test -e debian/control
	$(MAKE)


config.status:
	./configure \
	--prefix=/usr \
	--enable-states-type=indirect \
	--enable-max-num-freecells=8 \
	--enable-max-num-initial-cards-per-stack=104 \
	--enable-max--num-stacks=12 \
	--enable-max-num-decks=2 


binary-indep: build

#Build our packages.
binary-arch: build testroot debian/control
	#
	# Build libfreecell-solver0 package
	#
	
	make prefix=`pwd`/$(tmp)/usr install
	install -d --mode=755 $(tmp)/$(docdir)/$(PACKAGEshd)
	install -d --mode=755 $(tmp)/DEBIAN
	
	#
	# Remove cruft 
	#
	
	rm -rf $(tmp)/usr/bin
	rm -rf $(tmp)/usr/include
	rm -rf $(tmp)/usr/share/freecell-solver/preset*
	rm -f $(tmp)/usr/lib/*a
	rm -f $(tmp)/usr/lib/libfreecell-solver.so
	rm -rf $(tmp)/usr/man
	
	#
	# Install documentation
	#
	
	install --mode=644 "debian/copyright" $(tmp)/$(docdir)/$(PACKAGEshd)
	install --mode=644 "debian/changelog" \
	    $(tmp)/$(docdir)/$(PACKAGEshd)/changelog.Debian
	install --mode=644 "ChangeLog" \
		$(tmp)/$(docdir)/$(PACKAGEshd)/changelog
	install --mode=644 "NEWS"	      $(tmp)/$(docdir)/$(PACKAGEshd)
	install --mode=644 "README"	      $(tmp)/$(docdir)/$(PACKAGEshd)
	install --mode=644 "TODO"	      $(tmp)/$(docdir)/$(PACKAGEshd)
	install --mode=644 "CREDITS"	      $(tmp)/$(docdir)/$(PACKAGEshd)
	
	#
	# Compress changelogs
	#
	
	gzip -9f $(tmp)/$(docdir)/$(PACKAGEshd)/changelog*
	
	#
	# Strip the so and change its permssions.
	#
	
	strip --strip-all -R .comment -R .note \
	    $(tmp)/usr/lib/libfreecell-solver.so.*
	chmod 644 $(tmp)/usr/lib/libfreecell-solver.so.*
	
	#
	# Install package scripts
	#
	
	install --mode=644 debian/libfreecell-solver0.shlibs $(tmp)/DEBIAN/shlibs
	install --mode=755 debian/postinst.shd $(tmp)/DEBIAN/postinst
	chmod 755 $(tmp)/DEBIAN/postinst
	dpkg-shlibdeps $(tmp)/usr/lib/libfreecell-solver.so.*
	dpkg-gencontrol -ips -P$(tmp) -p$(PACKAGEshd)
	dpkg --build $(tmp) ..
	
	#----------------------------------------------------------------------#
	#
	# Build libfreecell-solver-dev package
	#
	
	make prefix=`pwd`/$(tmp-dev)/usr install
	install -d --mode=755 $(tmp-dev)/$(docdir)/$(PACKAGEdev)
	install -d --mode=755 $(tmp-dev)/DEBIAN
	
	#
	# Remove cruft
	#
	
	rm -rf $(tmp-dev)/usr/lib/*so*0*
	rm -rf $(tmp-dev)/usr/lib/*.la*
	rm -rf $(tmp-dev)/usr/bin
	rm -rf $(tmp-dev)/usr/share/freecell-solver/preset*
	rm -rf $(tmp-dev)/usr/man
	
	install -d --mode=755 $(tmp-dev)/usr/bin
	install --mode=755 "freecell-solver-config" $(tmp-dev)/usr/bin
	
	#
	# Install documentation
	#
	
	install --mode=644 "debian/copyright" $(tmp-dev)/$(docdir)/$(PACKAGEdev)
	install --mode=644 "debian/changelog" \
	    $(tmp-dev)/$(docdir)/$(PACKAGEdev)/changelog.Debian
	install --mode=644 "ChangeLog" \
		$(tmp-dev)/$(docdir)/$(PACKAGEdev)/changelog
	install --mode=644 "NEWS"	      $(tmp-dev)/$(docdir)/$(PACKAGEdev)
	install --mode=644 "README"	      $(tmp-dev)/$(docdir)/$(PACKAGEdev)
	install --mode=644 "TODO"	      $(tmp-dev)/$(docdir)/$(PACKAGEdev)
	install --mode=644 "CREDITS"	      $(tmp-dev)/$(docdir)/$(PACKAGEdev)
	install --mode=644 `find devel_docs -type f -maxdepth 1`        $(tmp-dev)/$(docdir)/$(PACKAGEdev)
	
	install -d --mode=755 $(tmp-dev)/usr/share/lintian/overrides
	install --mode=644 "debian/libfreecell-solver-dev.lintian" $(tmp-dev)/usr/share/lintian/overrides/libfreecell-solver-dev
	
	#
	# Strip the .a
	#
	
	strip --strip-debug $(tmp-dev)/usr/lib/libfreecell-solver.a
	
	#
	# Compress changelogs
	#
	
	gzip -9f $(tmp-dev)/$(docdir)/$(PACKAGEdev)/changelog*
	
	#
	# Install special files
	#
	
	dpkg-gencontrol -ips -P$(tmp-dev) -p$(PACKAGEdev)
	dpkg --build $(tmp-dev) ..
	
	
	#----------------------------------------------------------------------#
	#
	# Build freecell-solver-bin package
	#
	
	make prefix=`pwd`/$(tmp-bin)/usr install
	mv $(tmp-bin)/usr/bin/pi-make-microsoft-freecell-board $(tmp-bin)/usr/bin/make-microsoft-freecell-board
	rm $(tmp-bin)/usr/bin/freecell-solver-range-parallel-solve
	rm $(tmp-bin)/usr/bin/freecell-solver-config

	install -d --mode=755 $(tmp-bin)/$(docdir)/$(PACKAGEbin)
	install -d --mode=755 $(tmp-bin)/DEBIAN
	install -d --mode=755 $(tmp-bin)/$(mandir)/man6
	
	#
	# Remove cruft
	#
	
	rm -rf $(tmp-bin)/usr/man
	rm -rf $(tmp-bin)/usr/lib/
	rm -rf $(tmp-bin)/usr/include/
	
	#
	# Strip stuff
	#
	
	strip --strip-all -R .comment -R .note $(tmp-bin)/usr/bin/*board
	strip --strip-all -R .comment -R .note $(tmp-bin)/usr/bin/fc-solve
	
	#
	# Install documentation
	#
	
	install --mode=644 "debian/copyright" \
	    $(tmp-bin)/$(docdir)/$(PACKAGEbin)/copyright
	install --mode=644 "debian/changelog" \
	    $(tmp-bin)/$(docdir)/$(PACKAGEbin)/changelog.Debian
	install --mode=644 "ChangeLog" \
		$(tmp-bin)/$(docdir)/$(PACKAGEbin)/changelog
	install --mode=644 "NEWS"	      $(tmp-bin)/$(docdir)/$(PACKAGEbin)
	install --mode=644 "USAGE"	      $(tmp-bin)/$(docdir)/$(PACKAGEbin)
	install --mode=644 "README"	      $(tmp-bin)/$(docdir)/$(PACKAGEbin)
	install --mode=644 "TODO"	      $(tmp-bin)/$(docdir)/$(PACKAGEbin)
	install --mode=644 "CREDITS"	      $(tmp-bin)/$(docdir)/$(PACKAGEbin)
	install --mode=644 "fc-solve.6"	      $(tmp-bin)/$(mandir)/man6
	install --mode=644 board_gen/*.6      $(tmp-bin)/$(mandir)/man6
	install --mode=644 man/*.6            $(tmp-bin)/$(mandir)/man6
	mv $(tmp-bin)/$(mandir)/man6/pi-make-microsoft-freecell-board.6 $(tmp-bin)/$(mandir)/man6/make-microsoft-freecell-board.6
	chmod a+x $(tmp-bin)/usr/share/freecell-solver/presets/*
	
	#
	# Compress changelogs and man pages
	#
	
	gzip -9f $(tmp-bin)/$(docdir)/$(PACKAGEbin)/changelog*
	gzip -9f $(tmp-bin)/$(mandir)/man6/*
	
	rm $(tmp-bin)/$(mandir)/man6/make_pysol_freecell_board.py.6.gz
	rm $(tmp-bin)/$(mandir)/man6/make-microsoft-freecell-board.6.gz
	rm $(tmp-bin)/$(mandir)/man6/make-gnome-freecell-board.6.gz
	rm $(tmp-bin)/$(mandir)/man6/make-aisleriot-freecell-board.6.gz
	ln -s fc-solve-board_gen.6.gz $(tmp-bin)/$(mandir)/man6/make-aisleriot-freecell-board.6.gz
	ln -s fc-solve-board_gen.6.gz $(tmp-bin)/$(mandir)/man6/make_pysol_freecell_board.py.6.gz
	ln -s fc-solve-board_gen.6.gz $(tmp-bin)/$(mandir)/man6/make-microsoft-freecell-board.6.gz
	ln -s fc-solve-board_gen.6.gz $(tmp-bin)/$(mandir)/man6/make-gnome-freecell-board.6.gz
	#
	# Install special files
	#
	
	dpkg-shlibdeps $(tmp-bin)/usr/bin/*board $(tmp-bin)/usr/bin/fc-solve
	dpkg-gencontrol -ips -P$(tmp-bin) -p$(PACKAGEbin)
	dpkg --build $(tmp-bin) ..
	

clean: testroot
	test -e debian/control
	rm -f debian/substvars debian/files *orig* *bak* debian/*bak
	rm -rf debian/tmp
	rm -rf debian/tmp-dev
	rm -rf debian/tmp-bin
	-$(MAKE) distclean
	rm -f config.h config.log

binary: binary-indep binary-arch

testroot:
	test root = "`whoami`" || (echo Need root privelages; exit 1);

.PHONY: build binary-indep binary-arch binary clean

## freecell-solver 2.34.0

=== CMakeLists.txt ===
INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/Common.cmake" )

# This is the equivalent to perform a "make dist"/"make distdir" etc.
SET(CPACK_PACKAGE_NAME "freecell-solver")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Freecell Solver")
SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")

# Process and extract the version number.
FILE( READ "ver.txt" VERSION)

CHOMP (VERSION)

STRING (REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")

LIST(GET VERSION_DIGITS 0 CPACK_PACKAGE_VERSION_MAJOR)
LIST(GET VERSION_DIGITS 1 CPACK_PACKAGE_VERSION_MINOR)
LIST(GET VERSION_DIGITS 2 CPACK_PACKAGE_VERSION_PATCH)

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET(CPACK_SOURCE_IGNORE_FILES
    "/_CPack_Packages/"
    "/CMakeFiles/"
    "/.deps/"
    "freecell-solver-[0-9]+\\\\.[0-9]+\\\\.[0-9]+(-Source|-Linux|)(/|\\\\.(sh|tar\\\\.(gz|bz2|Z|lzma|xz))$)"
    "\\\\.o$"
    "~$"
    "/board_gen/(pi-make-microsoft-freecell-board|make-microsoft-freecell-board|make-gnome-freecell-board|make-aisleriot-freecell-board)$"
    "/(fc-solve|freecell-solver-range-parallel-solve|freecell-solver-fc-pro-range-solve|freecell-solver-multi-thread-solve)$"
    "/lib(fcs|freecell-solver)\\\\.(a|la)$"
    "\\\\.so(\\\\.[0-9]+)*$"
    "/\\\\.svn/"
    "/t/t/.*\\\\.exe$"
    "/t/Presets"
    "/CMakeCache\\\\.txt$"
    "/Makefile$"
    "/CTestTestfile\\\\.cmake$"
    "/cmake_install\\\\.cmake$"
    "/CPackConfig\\\\.cmake$"
    "/CPackSourceConfig\\\\.cmake$"
    "/tags$"
    "/freecell-solver-config$"
    "/libfreecell-solver\\\\.pc$"
    "/([0-9]+)\\\\.board$"
    "/config\\\\.h$"
    "/install_manifest\\\\.txt$"
    "/t/card-test-(parse|render)\\\\.c$"
    "/Testing/"
    "ids-whitelist\\\\.txt"
)

IF(WIN32 AND NOT UNIX)
    # There is a bug in NSI that does not handle full unix paths properly. Make
    # sure there is at least one set of four (4) backlasshes.
    SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}\\\\dondorf-king.bmp")
    SET(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\fc-solve.exe")
    SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\fc-solve.berlios.de")
    SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\fc-solve.berlios.de")
    SET(CPACK_NSIS_DISPLAY_NAME "Freecell Solver")
    SET(CPACK_NSIS_CONTACT "shlomif@iglu.org.il")
    SET(CPACK_NSIS_MODIFY_PATH ON)
    # Setting for NSIS :
    SET(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\fc-solve.ico")
    SET(CPACK_NSIS_MUI_UNIICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_PACKAGE_ICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_NSIS_MODIFY_PATH "ON")
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_STRIP_FILES "fc-solve")
  SET(CPACK_SOURCE_STRIP_FILES "")
ENDIF(WIN32 AND NOT UNIX)

SET(CPACK_PACKAGE_EXECUTABLES
    "fc-solve" "Single-Game Solver"
)

### This is to set the RPATH correctly, so when installed under a prefix
### the executables will find the libraries.
### 
### See:
###
### http://www.cmake.org/Wiki/CMake_RPATH_handling
###
### (Taken from that wiki page)

# use, i.e. don't skip the full RPATH for the build tree
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)


SET (STATES_TYPE "INDIRECT_STACK_STATES" CACHE STRING 
    "States Type ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES'). No need to usually change.")
SET (IA_STATE_PACKS_GROW_BY 32 CACHE STRING "Amount to Grow State Packs By")
SET (MAX_NUM_FREECELLS 8 CACHE STRING "Maximal Number of Freecells")
SET (MAX_NUM_STACKS 10 CACHE STRING "Maximal Number of Stacks")
SET (MAX_NUM_INITIAL_CARDS_IN_A_STACK 8 CACHE STRING
    "Maximal Number of Initial Cards in a Stack")
SET (MAX_NUM_DECKS 2 CACHE STRING "Maximal Number of Decks (1 or 2)")

SET (FCS_STATE_STORAGE "FCS_STATE_STORAGE_INTERNAL_HASH" CACHE STRING "The State Storage Type")
SET (FCS_STACK_STORAGE "FCS_STACK_STORAGE_INTERNAL_HASH" CACHE STRING "The Stack Storage Type")

SET (FCS_FREECELL_ONLY "" CACHE BOOL "Configure Freecell Solver to only be able to solve Freecell (not recommended)")
SET (FCS_DISABLE_SIMPLE_SIMON "" CACHE BOOL "Exclude being able to solve Simple Simon from the Binary (not recommended)")
SET (FCS_WITHOUT_CARD_FLIPPING "" CACHE BOOL "Exclude the flipping of cards from the binary.")
SET (FCS_WITH_TEST_SUITE "" CACHE BOOL "Also build and run the test suite.")

SET (FCS_ENABLE_SECONDARY_HASH_VALUE "" 
    CACHE BOOL 
    "Enable the secondary hash value calculation and track-keeping. Seems to slow things down."
)

SET (FCS_WITH_CONTEXT_VARIABLE "1" 
    CACHE BOOL 
    "Enable the context (extra void *) as passed to the comparison functions, etc."
)

SET (BUILD_STATIC_LIBRARY "1" CACHE BOOL "Whether to build the static library (which takes more time)" )

SET (CPU_ARCH "" CACHE STRING "A specific CPU architecture to pass to gcc")
SET (OPTIMIZATION_OMIT_FRAME_POINTER "" CACHE STRING "Use -fomit-frame-pointer with gcc (not recommended for debugging)")

SET (FCS_STATE_STORAGE_LIBAVL2_TREE_TYPE "avl" CACHE STRING "The libavl2 tree type used for the state storage. Ignored if not set to libavl2")
SET (FCS_STACK_STORAGE_LIBAVL2_TREE_TYPE "avl" CACHE STRING "The libavl2 tree type used for the stack storage. Ignored if not set to libavl2")
SET (LIBAVL2_SOURCE_DIR "/usr/src/avl-2.0.3" CACHE STRING "The location of the libavl2 source tree (from which files are copied)")

IF (NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES|DEBUG_STATES)$"))
    MESSAGE(FATAL_ERROR "STATES_TYPE should be ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES')")
ENDIF(NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES|DEBUG_STATES)$"))

SET (${STATES_TYPE} 1)

SET (FREECELL_SOLVER_LIB_MODULES alloc.c app_str.c card.c check_and_add_state.c cmd_line.c freecell.c instance.c lib.c move.c move_funcs_maps.c move_funcs_order.c preset.c scans.c simpsim.c split_cmd_line.c state.c)

IF (FCS_FREECELL_ONLY)
    LIST (REMOVE_ITEM FREECELL_SOLVER_LIB_MODULES preset.c)
    SET (FCS_DISABLE_SIMPLE_SIMON 1)
ENDIF (FCS_FREECELL_ONLY)

IF (FCS_DISABLE_SIMPLE_SIMON)
    LIST (REMOVE_ITEM FREECELL_SOLVER_LIB_MODULES simpsim.c)
ENDIF (FCS_DISABLE_SIMPLE_SIMON)

# Add the fcs_hash.c if (and only if) it is being used.
# 
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INTERNAL_HASH") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_INTERNAL_HASH"))

    LIST(APPEND FREECELL_SOLVER_LIB_MODULES fcs_hash.c)

ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INTERNAL_HASH") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_INTERNAL_HASH"))

# Add fcs_dm.c if (and only if) it is being used.
# 
IF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INDIRECT")
    LIST(APPEND FREECELL_SOLVER_LIB_MODULES fcs_dm.c)
ENDIF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INDIRECT")

# Search for libredblack if appropriate.
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBREDBLACK_TREE") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBREDBLACK_TREE"))

    FIND_LIBRARY(LIBREDBLACK_LIB redblack)

ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBREDBLACK_TREE") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBREDBLACK_TREE"))

# Search for Judy ( http://judy.sourceforge.net/ ) if appropriate.
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY"))

    FIND_LIBRARY(LIBJUDY_LIB Judy)

ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
       (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY"))

SET (LIBAVL2_COPIED_MODULES_DIR "${CMAKE_CURRENT_SOURCE_DIR}/libavl2")

# Initialize to the empty list - it may or may not be populated.
SET (LIBAVL2_TREE_TYPES )

MACRO(ADD_TREE_TYPE TREE_TYPE)
    LIST(APPEND LIBAVL2_TREE_TYPES ${TREE_TYPE})
    LIST(REMOVE_DUPLICATES LIBAVL2_TREE_TYPES)
ENDMACRO(ADD_TREE_TYPE TREE_TYPE)

IF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBAVL2_TREE")
    SET (TREE_TYPE "${FCS_STATE_STORAGE_LIBAVL2_TREE_TYPE}")
    ADD_TREE_TYPE("${TREE_TYPE}")
    FILE (MAKE_DIRECTORY "${LIBAVL2_COPIED_MODULES_DIR}")
    INCLUDE_DIRECTORIES(BEFORE "${LIBAVL2_COPIED_MODULES_DIR}")
    SET (MPROT "FC_SOLVE__STATE_STORAGE_H")
    SET (PREFIXO "fcs_libavl2_states_tree")
    FILE (WRITE "${LIBAVL2_COPIED_MODULES_DIR}/fcs_libavl2_state_storage.h"
"
#ifndef ${MPROT}
#define ${MPROT}

#include \"${TREE_TYPE}.h\"

typedef struct ${TREE_TYPE}_table ${PREFIXO}_table_t;
#define ${PREFIXO}_insert(a,b) ${TREE_TYPE}_insert((a),(b))
#define ${PREFIXO}_create(a,b,c) ${TREE_TYPE}_create((a),(b),(c))
#define ${PREFIXO}_destroy(a,b) ${TREE_TYPE}_destroy((a),(b))

#endif /* ${MPROT} */
"
)

ENDIF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBAVL2_TREE")

IF (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBAVL2_TREE")
    SET (TREE_TYPE "${FCS_STACK_STORAGE_LIBAVL2_TREE_TYPE}")
    ADD_TREE_TYPE("${TREE_TYPE}")    
    FILE (MAKE_DIRECTORY "${LIBAVL2_COPIED_MODULES_DIR}")
    SET (MPROT "FC_SOLVE__STACK_STORAGE_H")
    SET (PREFIXO "fcs_libavl2_stacks_tree")
    FILE (WRITE "${LIBAVL2_COPIED_MODULES_DIR}/fcs_libavl2_stack_storage.h"
"
#ifndef ${MPROT}
#define ${MPROT}

#include \"${TREE_TYPE}.h\"

typedef struct ${TREE_TYPE}_table ${PREFIXO}_table_t;
#define ${PREFIXO}_insert(a,b) ${TREE_TYPE}_insert((a),(b))
#define ${PREFIXO}_create(a,b,c) ${TREE_TYPE}_create((a),(b),(c))
#define ${PREFIXO}_destroy(a,b) ${TREE_TYPE}_destroy((a),(b))

#endif /* ${MPROT} */
"
    )

ENDIF (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBAVL2_TREE")

IF (LIBAVL2_TREE_TYPES)
    INCLUDE_DIRECTORIES(BEFORE "${LIBAVL2_COPIED_MODULES_DIR}")
    FOREACH (TREE_TYPE ${LIBAVL2_TREE_TYPES})
        SET (C_FN "${TREE_TYPE}.c")
        SET (H_FN "${TREE_TYPE}.h")
        CONFIGURE_FILE ("${LIBAVL2_SOURCE_DIR}/${C_FN}" 
            "${LIBAVL2_COPIED_MODULES_DIR}/${C_FN}"
            COPYONLY
        )
        CONFIGURE_FILE ("${LIBAVL2_SOURCE_DIR}/${H_FN}" 
            "${LIBAVL2_COPIED_MODULES_DIR}/${H_FN}"
            COPYONLY
        )
        LIST(APPEND FREECELL_SOLVER_LIB_MODULES "${LIBAVL2_COPIED_MODULES_DIR}/${C_FN}")
    ENDFOREACH (TREE_TYPE ${LIBAVL2_TREE_TYPES})
ENDIF (LIBAVL2_TREE_TYPES)

SET (MY_LINK_FLAGS "")
SET (MY_TO_PROFILE "")
IF (CMAKE_BUILD_TYPE STREQUAL profile)
    SET (MY_TO_PROFILE "1")
    SET (CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_DEBUG} -pg")
    SET (MY_LINK_FLAGS "-pg -static-libgcc")
    SET (BUILD_STATIC_LIBRARY "1")
    SET (MY_TARGET_LINK_LIBS "freecell-solver-static" "m_p" "c_p")
ELSE (CMAKE_BUILD_TYPE STREQUAL profile)
    SET (MY_TARGET_LINK_LIBS "freecell-solver")
ENDIF (CMAKE_BUILD_TYPE STREQUAL profile)

INCLUDE(CPack)

include(CheckFunctionExists)
INCLUDE(CheckCCompilerFlag)
INCLUDE(FindThreads)

ADD_SUBDIRECTORY ("board_gen")
ADD_SUBDIRECTORY ("man")
ADD_SUBDIRECTORY ("Presets")
ADD_SUBDIRECTORY ("t")

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

SET(COMPILER_FLAGS_TO_CHECK 
    "-Wall" "-Werror=implicit-function-declaration" "-fvisibility=hidden"
)

IF (CPU_ARCH)
    LIST(APPEND COMPILER_FLAGS_TO_CHECK "-march=${CPU_ARCH}")
ENDIF(CPU_ARCH)

IF (OPTIMIZATION_OMIT_FRAME_POINTER)
    LIST(APPEND COMPILER_FLAGS_TO_CHECK "-fomit-frame-pointer")
ENDIF(OPTIMIZATION_OMIT_FRAME_POINTER)

SET (IDX 1)
FOREACH (CFLAG_TO_CHECK ${COMPILER_FLAGS_TO_CHECK})
    SET (FLAG_EXISTS_VAR "FLAG_EXISTS_${IDX}")
    MATH (EXPR IDX "${IDX} + 1")

=== Presets/presets/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,12 @@
         "cool-jives.sh"
         "crooked-nose.sh"
         "fools-gold.sh"
+        "gooey-unknown-thing.sh"
         "hello-world.sh"
         "john_galt_line-500.sh"
         "rin-tin-tin.sh"
+        "sand-stone.sh"
+        "toons-for-twenty-somethings.sh"
         "yellow-brick-road.sh"
     DESTINATION
         "${PKGDATADIR}/presets"

## freecell-solver 3.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,13 @@
 INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/Common.cmake" )
+
+LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 # This is the equivalent to perform a "make dist"/"make distdir" etc.
 SET(CPACK_PACKAGE_NAME "freecell-solver")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Freecell Solver")
 SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
-SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
-SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
+SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
+SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.txt")
 
 # Process and extract the version number.
 FILE( READ "ver.txt" VERSION)
@@ -21,19 +23,23 @@
 SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 
 SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
+
+SET (base_with_ver "freecell-solver-[0-9]+\\\\.[0-9]+\\\\.[0-9]+")
 
 SET(CPACK_SOURCE_IGNORE_FILES
     "/_CPack_Packages/"
     "/CMakeFiles/"
     "/.deps/"
-    "freecell-solver-[0-9]+\\\\.[0-9]+\\\\.[0-9]+(-Source|-Linux|)(/|\\\\.(sh|tar\\\\.(gz|bz2|Z|lzma|xz))$)"
+    "^${base_with_ver}(-Source|-Linux)?/"
+    "${base_with_ver}.tar\\\\.(gz|bz2|Z|lzma|xz)$"
     "\\\\.o$"
     "~$"
     "/board_gen/(pi-make-microsoft-freecell-board|make-microsoft-freecell-board|make-gnome-freecell-board|make-aisleriot-freecell-board)$"
-    "/(fc-solve|freecell-solver-range-parallel-solve|freecell-solver-fc-pro-range-solve|freecell-solver-multi-thread-solve)$"
+    "/(fc-solve|freecell-solver-range-parallel-solve|freecell-solver-fc-pro-range-solve|freecell-solver-multi-thread-solve|freecell-solver-fork-solve|measure-depth-dep-tests-order-perf)$"
     "/lib(fcs|freecell-solver)\\\\.(a|la)$"
     "\\\\.so(\\\\.[0-9]+)*$"
     "/\\\\.svn/"
+    "\\\\.(pdf|fo)$"
     "/t/t/.*\\\\.exe$"
     "/t/Presets"
     "/CMakeCache\\\\.txt$"
@@ -79,7 +85,7 @@
 
 ### This is to set the RPATH correctly, so when installed under a prefix
 ### the executables will find the libraries.
-### 
+###
 ### See:
 ###
 ### http://www.cmake.org/Wiki/CMake_RPATH_handling
@@ -91,41 +97,59 @@
 
 # when building, don't use the install RPATH already
 # (but later on when installing)
-SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
+SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 
 # the RPATH to be used when installing
-SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
 
 # add the automatically determined parts of the RPATH
 # which point to directories outside the build tree to the install RPATH
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 
 
-SET (STATES_TYPE "INDIRECT_STACK_STATES" CACHE STRING 
+SET (STATES_TYPE "INDIRECT_STACK_STATES" CACHE STRING
     "States Type ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES'). No need to usually change.")
+SET (FCS_ENABLE_RCS_STATES CACHE BOOL "Whether to use RCS-like states (requires a STATES_TYPE of COMPACT_STATES")
 SET (IA_STATE_PACKS_GROW_BY 32 CACHE STRING "Amount to Grow State Packs By")
+SET (FCS_IA_PACK_SIZE 64 CACHE STRING "Size of a single pack in kilo-bytes.")
 SET (MAX_NUM_FREECELLS 8 CACHE STRING "Maximal Number of Freecells")
 SET (MAX_NUM_STACKS 10 CACHE STRING "Maximal Number of Stacks")
 SET (MAX_NUM_INITIAL_CARDS_IN_A_STACK 8 CACHE STRING
     "Maximal Number of Initial Cards in a Stack")
 SET (MAX_NUM_DECKS 2 CACHE STRING "Maximal Number of Decks (1 or 2)")
+SET (MAX_NUM_BENCHMARK_THREADS 4 CACHE STRING "Maximal Number of Threads to Use When Benchmarking")
 
 SET (FCS_STATE_STORAGE "FCS_STATE_STORAGE_INTERNAL_HASH" CACHE STRING "The State Storage Type")
 SET (FCS_STACK_STORAGE "FCS_STACK_STORAGE_INTERNAL_HASH" CACHE STRING "The Stack Storage Type")
 
+SET (FCS_WHICH_COLUMNS_GOOGLE_HASH "FCS_WHICH_COLUMNS_GOOGLE_HASH__SPARSE" CACHE STRING "The Columns' Google Hash Type")
+SET (FCS_WHICH_STATES_GOOGLE_HASH "FCS_WHICH_STATES_GOOGLE_HASH__SPARSE" CACHE STRING "The States/Positions' Google Hash Type")
+
 SET (FCS_FREECELL_ONLY "" CACHE BOOL "Configure Freecell Solver to only be able to solve Freecell (not recommended)")
 SET (FCS_DISABLE_SIMPLE_SIMON "" CACHE BOOL "Exclude being able to solve Simple Simon from the Binary (not recommended)")
-SET (FCS_WITHOUT_CARD_FLIPPING "" CACHE BOOL "Exclude the flipping of cards from the binary.")
+SET (FCS_WITHOUT_CARD_FLIPPING "1" CACHE BOOL "Exclude the flipping of cards from the binary.")
 SET (FCS_WITH_TEST_SUITE "" CACHE BOOL "Also build and run the test suite.")
-
-SET (FCS_ENABLE_SECONDARY_HASH_VALUE "" 
-    CACHE BOOL 
+SET (FCS_LINK_TO_STATIC "" CACHE BOOL "Link to the static library.")
+SET (FCS_HARD_CODED_NUM_FCS_FOR_FREECELL_ONLY "4" CACHE STRING "The hard-coded number of freecells (4, 2, etc.). Usually ignored")
+
+SET (FCS_ENABLE_SECONDARY_HASH_VALUE ""
+    CACHE BOOL
     "Enable the secondary hash value calculation and track-keeping. Seems to slow things down."
 )
 
-SET (FCS_WITH_CONTEXT_VARIABLE "1" 
-    CACHE BOOL 
+SET (FCS_WITH_CONTEXT_VARIABLE "1"
+    CACHE BOOL
     "Enable the context (extra void *) as passed to the comparison functions, etc."
+)
+
+SET (FCS_INLINED_HASH_COMPARISON "1"
+    CACHE BOOL
+    "Use more compact tokens for moves internally (makes things slower)"
+)
+
+SET (FCS_AVOID_TCMALLOC ""
+    CACHE BOOL
+    "Avoid linking against Google's tcmalloc"
 )
 
 SET (BUILD_STATIC_LIBRARY "1" CACHE BOOL "Whether to build the static library (which takes more time)" )
@@ -137,11 +161,19 @@
 SET (FCS_STACK_STORAGE_LIBAVL2_TREE_TYPE "avl" CACHE STRING "The libavl2 tree type used for the stack storage. Ignored if not set to libavl2")
 SET (LIBAVL2_SOURCE_DIR "/usr/src/avl-2.0.3" CACHE STRING "The location of the libavl2 source tree (from which files are copied)")
 
+SET (FCS_WITHOUT_VISITED_ITER "" CACHE BOOL "Disable the visited_iter counter in each state (somewhat useful for debugging, otherwise not needed.)")
+SET (FCS_WITHOUT_DEPTH_FIELD "" CACHE BOOL "Disable the depth field in each state (not absolutely necessary.)")
+SET (FCS_WITHOUT_LOCS_FIELDS "" CACHE BOOL "Disable the columns and freecells permutations fields in each state (they are not absolutely necessary.)")
+
 IF (NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES|DEBUG_STATES)$"))
     MESSAGE(FATAL_ERROR "STATES_TYPE should be ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES')")
 ENDIF(NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES|DEBUG_STATES)$"))
 
 SET (${STATES_TYPE} 1)
+
+IF (FCS_ENABLE_RCS_STATES)
+    SET (FCS_RCS_STATES 1)
+ENDIF (FCS_ENABLE_RCS_STATES)
 
 SET (FREECELL_SOLVER_LIB_MODULES alloc.c app_str.c card.c check_and_add_state.c cmd_line.c freecell.c instance.c lib.c move.c move_funcs_maps.c move_funcs_order.c preset.c scans.c simpsim.c split_cmd_line.c state.c)
 
@@ -154,8 +186,13 @@
     LIST (REMOVE_ITEM FREECELL_SOLVER_LIB_MODULES simpsim.c)
 ENDIF (FCS_DISABLE_SIMPLE_SIMON)
 
+IF (NOT (${STATES_TYPE} STREQUAL "INDIRECT_STACK_STATES"))
+    # FCS_STACK_STORAGE in this case is irrelevant and should be ignored.
+    SET (FCS_STACK_STORAGE "FCS_STACK_STORAGE_NULL")
+ENDIF (NOT (${STATES_TYPE} STREQUAL "INDIRECT_STACK_STATES"))
+
 # Add the fcs_hash.c if (and only if) it is being used.
-# 
+#
 IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INTERNAL_HASH") OR
     (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_INTERNAL_HASH"))
 
@@ -164,8 +201,19 @@
 ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INTERNAL_HASH") OR
     (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_INTERNAL_HASH"))
 
+
+# Add the google_hash.cpp if (and only if) it is being used.
+#
+IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_GOOGLE_DENSE_HASH") OR
+    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_GOOGLE_DENSE_HASH"))
+
+    LIST(APPEND FREECELL_SOLVER_LIB_MODULES google_hash.cpp)
+
+ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_GOOGLE_DENSE_HASH") OR
+    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_GOOGLE_DENSE_HASH"))
+
 # Add fcs_dm.c if (and only if) it is being used.
-# 
+#
 IF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INDIRECT")
     LIST(APPEND FREECELL_SOLVER_LIB_MODULES fcs_dm.c)
 ENDIF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INDIRECT")
@@ -181,12 +229,14 @@
 
 # Search for Judy ( http://judy.sourceforge.net/ ) if appropriate.
 IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
-    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY"))
+    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY") OR
+    FCS_RCS_STATES)
 
     FIND_LIBRARY(LIBJUDY_LIB Judy)
 
 ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
-       (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY"))
+(${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY") OR
+    FCS_RCS_STATES)
 
 SET (LIBAVL2_COPIED_MODULES_DIR "${CMAKE_CURRENT_SOURCE_DIR}/libavl2")
 
@@ -225,83 +275,5 @@
 
 IF (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBAVL2_TREE")
     SET (TREE_TYPE "${FCS_STACK_STORAGE_LIBAVL2_TREE_TYPE}")
-    ADD_TREE_TYPE("${TREE_TYPE}")    
+    ADD_TREE_TYPE("${TREE_TYPE}")
     FILE (MAKE_DIRECTORY "${LIBAVL2_COPIED_MODULES_DIR}")
-    SET (MPROT "FC_SOLVE__STACK_STORAGE_H")
-    SET (PREFIXO "fcs_libavl2_stacks_tree")
-    FILE (WRITE "${LIBAVL2_COPIED_MODULES_DIR}/fcs_libavl2_stack_storage.h"
-"
-#ifndef ${MPROT}
-#define ${MPROT}
-
-#include \"${TREE_TYPE}.h\"
-
-typedef struct ${TREE_TYPE}_table ${PREFIXO}_table_t;
-#define ${PREFIXO}_insert(a,b) ${TREE_TYPE}_insert((a),(b))
-#define ${PREFIXO}_create(a,b,c) ${TREE_TYPE}_create((a),(b),(c))
-#define ${PREFIXO}_destroy(a,b) ${TREE_TYPE}_destroy((a),(b))
-
-#endif /* ${MPROT} */
-"
-    )
-
-ENDIF (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBAVL2_TREE")
-
-IF (LIBAVL2_TREE_TYPES)
-    INCLUDE_DIRECTORIES(BEFORE "${LIBAVL2_COPIED_MODULES_DIR}")
-    FOREACH (TREE_TYPE ${LIBAVL2_TREE_TYPES})
-        SET (C_FN "${TREE_TYPE}.c")
-        SET (H_FN "${TREE_TYPE}.h")
-        CONFIGURE_FILE ("${LIBAVL2_SOURCE_DIR}/${C_FN}" 
-            "${LIBAVL2_COPIED_MODULES_DIR}/${C_FN}"
-            COPYONLY
-        )
-        CONFIGURE_FILE ("${LIBAVL2_SOURCE_DIR}/${H_FN}" 
-            "${LIBAVL2_COPIED_MODULES_DIR}/${H_FN}"
-            COPYONLY
-        )
-        LIST(APPEND FREECELL_SOLVER_LIB_MODULES "${LIBAVL2_COPIED_MODULES_DIR}/${C_FN}")
-    ENDFOREACH (TREE_TYPE ${LIBAVL2_TREE_TYPES})
-ENDIF (LIBAVL2_TREE_TYPES)
-
-SET (MY_LINK_FLAGS "")
-SET (MY_TO_PROFILE "")
-IF (CMAKE_BUILD_TYPE STREQUAL profile)
-    SET (MY_TO_PROFILE "1")
-    SET (CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_DEBUG} -pg")
-    SET (MY_LINK_FLAGS "-pg -static-libgcc")
-    SET (BUILD_STATIC_LIBRARY "1")
-    SET (MY_TARGET_LINK_LIBS "freecell-solver-static" "m_p" "c_p")
-ELSE (CMAKE_BUILD_TYPE STREQUAL profile)
-    SET (MY_TARGET_LINK_LIBS "freecell-solver")
-ENDIF (CMAKE_BUILD_TYPE STREQUAL profile)
-
-INCLUDE(CPack)
-
-include(CheckFunctionExists)
-INCLUDE(CheckCCompilerFlag)
-INCLUDE(FindThreads)
-
-ADD_SUBDIRECTORY ("board_gen")
-ADD_SUBDIRECTORY ("man")
-ADD_SUBDIRECTORY ("Presets")
-ADD_SUBDIRECTORY ("t")
-
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
-
-SET(COMPILER_FLAGS_TO_CHECK 
-    "-Wall" "-Werror=implicit-function-declaration" "-fvisibility=hidden"
-)
-
-IF (CPU_ARCH)
-    LIST(APPEND COMPILER_FLAGS_TO_CHECK "-march=${CPU_ARCH}")
-ENDIF(CPU_ARCH)
-
-IF (OPTIMIZATION_OMIT_FRAME_POINTER)
-    LIST(APPEND COMPILER_FLAGS_TO_CHECK "-fomit-frame-pointer")
-ENDIF(OPTIMIZATION_OMIT_FRAME_POINTER)
-
-SET (IDX 1)
-FOREACH (CFLAG_TO_CHECK ${COMPILER_FLAGS_TO_CHECK})
-    SET (FLAG_EXISTS_VAR "FLAG_EXISTS_${IDX}")
-    MATH (EXPR IDX "${IDX} + 1")
